//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// updated February, 2014

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#include <stdio.h>
#include <GL/glut.h>
#include <math.h>

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

int w = 500;
int h = 500;

float theta_start = 0.0;
float circle_radius = w/4;
float circle_x = w/2;
float circle_y = h/2;
float delta_theta = 0.1 * M_PI;
float theta_speed = 0.005;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

void mouse(int button, int state, int x, int y)
{
  if (button == GLUT_LEFT_BUTTON && state == GLUT_UP) {
      circle_x = x;
      circle_y = h - y;
      glutPostRedisplay();
  }
}

//----------------------------------------------------------------------------

void keyboard(char unsigned key, int x, int y)
{
  if (key == 'a' && circle_radius >= 1) {
    circle_radius -= 5;
    glutPostRedisplay();
  }
  else if (key == 'd' && circle_radius <= w/2) {
    circle_radius += 5;
    glutPostRedisplay();
  }
  else if (key == 'z') {
    theta_speed -= 0.001;
    glutPostRedisplay();
  }
  else if (key == 'c') {
    theta_speed += 0.001;
    glutPostRedisplay();
  }
  else if (key == 'q')
    exit(1);
}

//----------------------------------------------------------------------------

void idle()
{
  theta_start -= theta_speed;

  glutPostRedisplay();
}

//----------------------------------------------------------------------------

void display_circle_points() 
{
  float theta;

  glClear(GL_COLOR_BUFFER_BIT);

  glColor3ub(255, 255, 255);
  glPointSize(5);

  glBegin(GL_POINTS);
  //glBegin(GL_LINE_LOOP);
  for (theta = theta_start; theta < theta_start + 2*M_PI; theta += delta_theta)
    glVertex2f(circle_x + circle_radius * cos(theta), 
	       circle_y + circle_radius * sin(theta));
  glEnd();

  glutSwapBuffers();
}

//----------------------------------------------------------------------------

void init() 
{
  printf("Click to reposition circle\n");
  printf("Press a to reduce radius, d to increase\n");
  printf("z to reduce spin speed, c to increase\n");
  printf("q to quit\n");
  
  glClearColor(0.0, 0.0, 0.0, 0.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluOrtho2D(0, w, 0, h);
}

//----------------------------------------------------------------------------

int main(int argc, char** argv)
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
  glutInitWindowSize(w, h);
  glutCreateWindow("hello");
  init(); 			            // set OpenGL states, variables
  
  // register callback routines

  glutDisplayFunc(display_circle_points);         
  glutMouseFunc(mouse);
  glutKeyboardFunc(keyboard);
  glutIdleFunc(idle);

  glutMainLoop(); 		    // enter event-driven loop

  return 1;
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
